pcl::Narf Class Reference
Module features

NARF (Normal Aligned Radial Features) is a point feature descriptor type for 3D data. More...

`#include <pcl/features/narf.h>`

## Classes

struct | FeaturePointRepresentation

## Public Member Functions

| Narf ()
| Constructor. More...
| Narf (const Narf &other)
| Copy Constructor. More...
| ~Narf ()
| Destructor. More...
const Narf & | operator= (const Narf &other)
| Assignment operator. More...
bool | extractFromRangeImage (const RangeImage &range_image, const Eigen::Affine3f &pose, int descriptor_size, float support_size, int surface_patch_world_size=NARF_DEFAULT_SURFACE_PATCH_PIXEL_SIZE)
| Method to extract a NARF feature from a certain 3D point using a range image. More...
bool | extractFromRangeImage (const RangeImage &range_image, float x, float y, int descriptor_size, float support_size)
| Same as above, but determines the transformation from the surface in the range image. More...
bool | extractFromRangeImage (const RangeImage &range_image, const InterestPoint &interest_point, int descriptor_size, float support_size)
| Same as above. More...
bool | extractFromRangeImage (const RangeImage &range_image, const Eigen::Vector3f &interest_point, int descriptor_size, float support_size)
| Same as above. More...
bool | extractFromRangeImageWithBestRotation (const RangeImage &range_image, const Eigen::Vector3f &interest_point, int descriptor_size, float support_size)
| Same as above, but using the rotational invariant version by choosing the best extracted rotation around the normal. More...
void | getRotations (std::vector< float > &rotations, std::vector< float > &strengths) const
void | getRotatedVersions (const RangeImage &range_image, const std::vector< float > &rotations, std::vector< Narf * > &features) const
float | getDescriptorDistance (const Narf &other) const
| Calculate descriptor distance, value in [0,1] with 0 meaning identical and 1 every cell above maximum distance. More...
int | getNoOfBeamPoints () const
| How many points on each beam of the gradient star are used to calculate the descriptor? More...
void | copyToNarf36 (Narf36 &narf36) const
| Copy the descriptor and pose to the point struct Narf36. More...
void | saveBinary (const std::string &filename) const
| Write to file. More...
void | saveBinary (std::ostream &file) const
| Write to output stream. More...
void | loadBinary (const std::string &filename)
| Read from file. More...
void | loadBinary (std::istream &file)
| Read from input stream. More...
bool | extractDescriptor (int descriptor_size)
| Create the descriptor from the already set other members. More...
const float * | getDescriptor () const
| Getter (const) for the descriptor. More...
float * | getDescriptor ()
| Getter for the descriptor. More...
const int & | getDescriptorSize () const
| Getter (const) for the descriptor length. More...
int & | getDescriptorSize ()
| Getter for the descriptor length. More...
const Eigen::Vector3f & | getPosition () const
| Getter (const) for the position. More...
Eigen::Vector3f & | getPosition ()
| Getter for the position. More...
const Eigen::Affine3f & | getTransformation () const
| Getter (const) for the 6DoF pose. More...
Eigen::Affine3f & | getTransformation ()
| Getter for the 6DoF pose. More...
const int & | getSurfacePatchPixelSize () const
| Getter (const) for the pixel size of the surface patch (only one dimension) More...
int & | getSurfacePatchPixelSize ()
| Getter for the pixel size of the surface patch (only one dimension) More...
const float & | getSurfacePatchWorldSize () const
| Getter (const) for the world size of the surface patch. More...
float & | getSurfacePatchWorldSize ()
| Getter for the world size of the surface patch. More...
const float & | getSurfacePatchRotation () const
| Getter (const) for the rotation of the surface patch. More...
float & | getSurfacePatchRotation ()
| Getter for the rotation of the surface patch. More...
const float * | getSurfacePatch () const
| Getter (const) for the surface patch. More...
float * | getSurfacePatch ()
| Getter for the surface patch. More...
void | freeSurfacePatch ()
| Method to erase the surface patch and free the memory. More...
void | setDescriptor (float *descriptor)
| Setter for the descriptor. More...
void | setSurfacePatch (float *surface_patch)
| Setter for the surface patch. More...

## Static Public Member Functions

static void | extractFromRangeImageAndAddToList (const RangeImage &range_image, const Eigen::Vector3f &interest_point, int descriptor_size, float support_size, bool rotation_invariant, std::vector< Narf * > &feature_list)
| Add features extracted at the given interest point and add them to the list. More...
static void | extractFromRangeImageAndAddToList (const RangeImage &range_image, float image_x, float image_y, int descriptor_size, float support_size, bool rotation_invariant, std::vector< Narf * > &feature_list)
| Same as above. More...
static void | extractForInterestPoints (const RangeImage &range_image, const PointCloud< InterestPoint > &interest_points, int descriptor_size, float support_size, bool rotation_invariant, std::vector< Narf * > &feature_list)
| Get a list of features from the given interest points. More...
static void | extractForEveryRangeImagePointAndAddToList (const RangeImage &range_image, int descriptor_size, float support_size, bool rotation_invariant, std::vector< Narf * > &feature_list)
| Extract an NARF for every point in the range image. More...

## Static Public Attributes

static int | max_no_of_threads
| The maximum number of openmp threads that can be used in this class. More...

## Protected Member Functions

void | reset ()
| Reset al members to default values and free allocated memory. More...
void | deepCopy (const Narf &other)
| Create a deep copy of other. More...
float * | getBlurredSurfacePatch (int new_pixel_size, int blur_radius) const
| Get the surface patch with a blur on it. More...
void | saveHeader (std::ostream &file) const
| Write header to output stream. More...
int | loadHeader (std::istream &file) const
| Read header from input stream. More...

## Static Protected Member Functions

static const std::string | getHeaderKeyword ()

## Protected Attributes

Eigen::Vector3f | position_
Eigen::Affine3f | transformation_
float * | surface_patch_
int | surface_patch_pixel_size_
float | surface_patch_world_size_
float | surface_patch_rotation_
float * | descriptor_
int | descriptor_size_

## Static Protected Attributes

static const int | VERSION = 1

## Detailed Description

NARF (Normal Aligned Radial Features) is a point feature descriptor type for 3D data.

Please refer to pcl/features/narf_descriptor.h if you want the class derived from pcl Feature. See B. Steder, R. B. Rusu, K. Konolige, and W. Burgard Point Feature Extraction on 3D Range Scans Taking into Account Object Boundaries In Proc. of the IEEE Int. Conf. on Robotics &Automation (ICRA). 2011.

Author
  Bastian Steder

Definition at line 63 of file narf.h.

## Constructor & Destructor Documentation

pcl::Narf::Narf | ( |  | ) |

Constructor.

pcl::Narf::Narf | ( | const Narf & | other | ) |

Copy Constructor.

pcl::Narf::~Narf | ( |  | ) |

Destructor.

## Member Function Documentation

void pcl::Narf::copyToNarf36 | ( | Narf36 & | narf36 | ) | const

inline

Copy the descriptor and pose to the point struct Narf36.

Definition at line 53 of file narf.hpp.

References pcl::Narf36::descriptor, descriptor_, descriptor_size_, pcl::getTranslationAndEulerAngles(), pcl::Narf36::pitch, pcl::Narf36::roll, transformation_, pcl::Narf36::x, pcl::Narf36::y, pcl::Narf36::yaw, and pcl::Narf36::z.

void pcl::Narf::deepCopy | ( | const Narf & | other | ) |

protected

Create a deep copy of other.

bool pcl::Narf::extractDescriptor | ( | int | descriptor_size | ) |

Create the descriptor from the already set other members.

static void pcl::Narf::extractForEveryRangeImagePointAndAddToList | ( | const RangeImage & | range_image,
|  | int | descriptor_size,
|  | float | support_size,
|  | bool | rotation_invariant,
|  | std::vector< Narf * > & | feature_list
| ) |  |

static

Extract an NARF for every point in the range image.

static void pcl::Narf::extractForInterestPoints | ( | const RangeImage & | range_image,
|  | const PointCloud< InterestPoint > & | interest_points,
|  | int | descriptor_size,
|  | float | support_size,
|  | bool | rotation_invariant,
|  | std::vector< Narf * > & | feature_list
| ) |  |

static

Get a list of features from the given interest points.

bool pcl::Narf::extractFromRangeImage | ( | const RangeImage & | range_image,
|  | const Eigen::Affine3f & | pose,
|  | int | descriptor_size,
|  | float | support_size,
|  | int | surface_patch_world_size = `NARF_DEFAULT_SURFACE_PATCH_PIXEL_SIZE`
| ) |  |

Method to extract a NARF feature from a certain 3D point using a range image.

pose determines the coordinate system of the feature, whereas it transforms a point from the world into the feature system. This means the interest point at which the feature is extracted will be the inverse application of pose onto (0,0,0). descriptor_size_ determines the size of the descriptor, support_size determines the support size of the feature, meaning the size in the world it covers

bool pcl::Narf::extractFromRangeImage | ( | const RangeImage & | range_image,
|  | float | x,
|  | float | y,
|  | int | descriptor_size,
|  | float | support_size
| ) |  |

Same as above, but determines the transformation from the surface in the range image.

bool pcl::Narf::extractFromRangeImage | ( | const RangeImage & | range_image,
|  | const InterestPoint & | interest_point,
|  | int | descriptor_size,
|  | float | support_size
| ) |  |

Same as above.

bool pcl::Narf::extractFromRangeImage | ( | const RangeImage & | range_image,
|  | const Eigen::Vector3f & | interest_point,
|  | int | descriptor_size,
|  | float | support_size
| ) |  |

Same as above.

static void pcl::Narf::extractFromRangeImageAndAddToList | ( | const RangeImage & | range_image,
|  | const Eigen::Vector3f & | interest_point,
|  | int | descriptor_size,
|  | float | support_size,
|  | bool | rotation_invariant,
|  | std::vector< Narf * > & | feature_list
| ) |  |

static

Add features extracted at the given interest point and add them to the list.

static void pcl::Narf::extractFromRangeImageAndAddToList | ( | const RangeImage & | range_image,
|  | float | image_x,
|  | float | image_y,
|  | int | descriptor_size,
|  | float | support_size,
|  | bool | rotation_invariant,
|  | std::vector< Narf * > & | feature_list
| ) |  |

static

Same as above.

bool pcl::Narf::extractFromRangeImageWithBestRotation | ( | const RangeImage & | range_image,
|  | const Eigen::Vector3f & | interest_point,
|  | int | descriptor_size,
|  | float | support_size
| ) |  |

Same as above, but using the rotational invariant version by choosing the best extracted rotation around the normal.

Use extractFromRangeImageAndAddToList if you want to enable the system to return multiple features with different rotations.

void pcl::Narf::freeSurfacePatch | ( |  | ) |

inline

Method to erase the surface patch and free the memory.

Definition at line 224 of file narf.h.

float* pcl::Narf::getBlurredSurfacePatch | ( | int | new_pixel_size,
|  | int | blur_radius
| ) |  | const

protected

Get the surface patch with a blur on it.

const float* pcl::Narf::getDescriptor | ( |  | ) | const

inline

Getter (const) for the descriptor.

Definition at line 176 of file narf.h.

Referenced by pcl::Narf::FeaturePointRepresentation::copyToFloatArray().

float* pcl::Narf::getDescriptor | ( |  | ) |

inline

Getter for the descriptor.

Definition at line 179 of file narf.h.

float pcl::Narf::getDescriptorDistance | ( | const Narf & | other | ) | const

inline

Calculate descriptor distance, value in [0,1] with 0 meaning identical and 1 every cell above maximum distance.

Definition at line 45 of file narf.hpp.

References descriptor_, descriptor_size_, and pcl::L1_Norm().

const int& pcl::Narf::getDescriptorSize | ( |  | ) | const

inline

Getter (const) for the descriptor length.

Definition at line 182 of file narf.h.

int& pcl::Narf::getDescriptorSize | ( |  | ) |

inline

Getter for the descriptor length.

Definition at line 185 of file narf.h.

static const std::string pcl::Narf::getHeaderKeyword | ( |  | ) |

inline static protected

Definition at line 267 of file narf.h.

int pcl::Narf::getNoOfBeamPoints | ( |  | ) | const

inline

How many points on each beam of the gradient star are used to calculate the descriptor?

Definition at line 149 of file narf.h.

References pcl::loadBinary(), and pcl::saveBinary().

const Eigen::Vector3f& pcl::Narf::getPosition | ( |  | ) | const

inline

Getter (const) for the position.

Definition at line 188 of file narf.h.

Eigen::Vector3f& pcl::Narf::getPosition | ( |  | ) |

inline

Getter for the position.

Definition at line 191 of file narf.h.

void pcl::Narf::getRotatedVersions | ( | const RangeImage & | range_image,
|  | const std::vector< float > & | rotations,
|  | std::vector< Narf * > & | features
| ) |  | const

void pcl::Narf::getRotations | ( | std::vector< float > & | rotations,
|  | std::vector< float > & | strengths
| ) |  | const

const float* pcl::Narf::getSurfacePatch | ( |  | ) | const

inline

Getter (const) for the surface patch.

Definition at line 218 of file narf.h.

float* pcl::Narf::getSurfacePatch | ( |  | ) |

inline

Getter for the surface patch.

Definition at line 221 of file narf.h.

const int& pcl::Narf::getSurfacePatchPixelSize | ( |  | ) | const

inline

Getter (const) for the pixel size of the surface patch (only one dimension)

Definition at line 200 of file narf.h.

int& pcl::Narf::getSurfacePatchPixelSize | ( |  | ) |

inline

Getter for the pixel size of the surface patch (only one dimension)

Definition at line 203 of file narf.h.

const float& pcl::Narf::getSurfacePatchRotation | ( |  | ) | const

inline

Getter (const) for the rotation of the surface patch.

Definition at line 212 of file narf.h.

float& pcl::Narf::getSurfacePatchRotation | ( |  | ) |

inline

Getter for the rotation of the surface patch.

Definition at line 215 of file narf.h.

const float& pcl::Narf::getSurfacePatchWorldSize | ( |  | ) | const

inline

Getter (const) for the world size of the surface patch.

Definition at line 206 of file narf.h.

float& pcl::Narf::getSurfacePatchWorldSize | ( |  | ) |

inline

Getter for the world size of the surface patch.

Definition at line 209 of file narf.h.

const Eigen::Affine3f& pcl::Narf::getTransformation | ( |  | ) | const

inline

Getter (const) for the 6DoF pose.

Definition at line 194 of file narf.h.

Eigen::Affine3f& pcl::Narf::getTransformation | ( |  | ) |

inline

Getter for the 6DoF pose.

Definition at line 197 of file narf.h.

void pcl::Narf::loadBinary | ( | const std::string & | filename | ) |

Read from file.

void pcl::Narf::loadBinary | ( | std::istream & | file | ) |

Read from input stream.

int pcl::Narf::loadHeader | ( | std::istream & | file | ) | const

protected

Read header from input stream.

const Narf& pcl::Narf::operator= | ( | const Narf & | other | ) |

Assignment operator.

void pcl::Narf::reset | ( |  | ) |

protected

Reset al members to default values and free allocated memory.

void pcl::Narf::saveBinary | ( | const std::string & | filename | ) | const

Write to file.

void pcl::Narf::saveBinary | ( | std::ostream & | file | ) | const

Write to output stream.

void pcl::Narf::saveHeader | ( | std::ostream & | file | ) | const

protected

Write header to output stream.

void pcl::Narf::setDescriptor | ( | float * | descriptor | ) |

inline

Setter for the descriptor.

Definition at line 229 of file narf.h.

void pcl::Narf::setSurfacePatch | ( | float * | surface_patch | ) |

inline

Setter for the surface patch.

Definition at line 232 of file narf.h.

## Member Data Documentation

float* pcl::Narf::descriptor_

protected

Definition at line 279 of file narf.h.

Referenced by copyToNarf36(), and getDescriptorDistance().

int pcl::Narf::descriptor_size_

protected

Definition at line 280 of file narf.h.

Referenced by copyToNarf36(), and getDescriptorDistance().

int pcl::Narf::max_no_of_threads

static

The maximum number of openmp threads that can be used in this class.

Definition at line 80 of file narf.h.

Eigen::Vector3f pcl::Narf::position_

protected

Definition at line 273 of file narf.h.

float* pcl::Narf::surface_patch_

protected

Definition at line 275 of file narf.h.

int pcl::Narf::surface_patch_pixel_size_

protected

Definition at line 276 of file narf.h.

float pcl::Narf::surface_patch_rotation_

protected

Definition at line 278 of file narf.h.

float pcl::Narf::surface_patch_world_size_

protected

Definition at line 277 of file narf.h.

Eigen::Affine3f pcl::Narf::transformation_

protected

Definition at line 274 of file narf.h.

Referenced by copyToNarf36().

const int pcl::Narf::VERSION = 1

static protected

Definition at line 270 of file narf.h.

The documentation for this class was generated from the following files:

- /build/pcl-0nnAvv/pcl-1.7.2/features/include/pcl/features/narf.h
- /build/pcl-0nnAvv/pcl-1.7.2/features/include/pcl/features/impl/narf.hpp